<?php
/*------------------------------------------------------------------------
# com_zhgooglemap - Zh GoogleMap
# ------------------------------------------------------------------------
# author    Dmitry Zhuk
# copyright Copyright (C) 2011 zhuk.cc. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 or later
# Websites: http://zhuk.cc
# Technical Support Forum: http://forum.zhuk.cc/
-------------------------------------------------------------------------*/
// No direct access to this file
defined('_JEXEC') or die('Restricted access');

// import Joomla view library
jimport('joomla.application.component.view');

/**
 * View class for the ZhGoogle MapAdSences Component
 */
class ZhGoogleMapViewMapAdSences extends JView
{
	protected $state;

	// Overwriting JView display method
	function display($tpl = null) 
	{
                // Get data from the model
                $items = $this->get('Items');
                $pagination = $this->get('Pagination');

		$this->state = $this->get('State');


 		$mapList = $this->get('mapList');
		$this->assignRef( 'mapList',	$mapList);

                // Check for errors.
                if (count($errors = $this->get('Errors'))) 
                {
                        JError::raiseError(500, implode('<br />', $errors));
                        return false;
                }
                // Assign data to the view
                $this->items = $items;
                $this->pagination = $pagination;
 
                // Set the toolbar
                $this->addToolBar();
 
                // Display the template
                parent::display($tpl);

		// Set the document
		$this->setDocument();

	}

	/**
	 * Setting the toolbar
	 */
	protected function addToolBar() 
	{
		$canDo = ZhGoogleMapHelper::getAdSenceActions();
		JToolBarHelper::title(JText::_('COM_ZHGOOGLEMAP_MAPADSENCE_MANAGER'), 'mapadsence');
		if ($canDo->get('core.create')) 
		{
			JToolBarHelper::addNew('mapadsence.add', 'JTOOLBAR_NEW');
		}
		if ($canDo->get('core.edit')) 
		{
			JToolBarHelper::editList('mapadsence.edit', 'JTOOLBAR_EDIT');
		}
		if ($canDo->get('core.edit.state')) 
		{
				JToolBarHelper::divider();
				JToolBarHelper::publish('mapadsences.publish', 'JTOOLBAR_PUBLISH', true);
				JToolBarHelper::unpublish('mapadsences.unpublish', 'JTOOLBAR_UNPUBLISH', true);
				JToolBarHelper::divider();
		}
		if ($canDo->get('core.delete')) 
		{
			JToolBarHelper::deleteList('', 'mapadsences.delete', 'JTOOLBAR_DELETE');
		}
		if ($canDo->get('core.admin')) 
		{
			JToolBarHelper::divider();
			JToolBarHelper::preferences('com_zhgooglemap');
		}
	}
	/**
	 * Method to set up the document properties
	 *
	 * @return void
	 */
	protected function setDocument() 
	{
		$document = JFactory::getDocument();
		$document->setTitle(JText::_('COM_ZHGOOGLEMAP_MAPADSENCE_ADMINISTRATION'));
	}

}
